#include "Actors/MujocoStaticMeshActor.h"
#include "EngineUtils.h"
#include "Components/MujocoBodyComponent.h"
#include "Components/MujocoActuatorComponent.h"
#include "Components/MujocoEqualityComponent.h"
#include "Components/MujocoTendonComponent.h"

AMujocoStaticMeshActor::AMujocoStaticMeshActor()
{
	PrimaryActorTick.bCanEverTick = false;
}

#if WITH_EDITOR

void AMujocoStaticMeshActor::PostDuplicate(EDuplicateMode::Type DuplicateMode)
{
	Super::PostDuplicate(DuplicateMode);
}

void AMujocoStaticMeshActor::PreDuplicate(FObjectDuplicationParameters& DupParams)
{
	FString SourceName = DupParams.SourceObject->GetName();

	uint32 Counter = 0;
	for (TActorIterator<AMujocoStaticMeshActor> It(GetWorld()); It; ++It)
	{
		if (It->GetName().StartsWith(SourceName))
		{
			Counter++;
		}
	}

	FString NewName = FString::Printf(TEXT("%s_%d"), *SourceName, Counter);
	DupParams.DestName = *NewName;	

	Super::PreDuplicate(DupParams);
}

#endif