#include "Components/MujocoJointComponent.h"
#include "Components/MujocoBodyComponent.h"

UMujocoJointComponent::UMujocoJointComponent()
{
    PrimaryComponentTick.bCanEverTick = false;
}

#if WITH_EDITORONLY_DATA
void UMujocoJointComponent::OnComponentCreated() 
{
	Super::OnComponentCreated();
	if (GEngine && GetWorld())
	{
		if (UMujocoBodyComponent* ParentBody = Cast<UMujocoBodyComponent>(GetAttachParent()))
		{
			FString BodyName = ParentBody->GetName();
			FString UniqueName = GenerateUniqueName(GetWorld(), this, BodyName + TEXT("_Joint"));
			Rename(*UniqueName);
		}
		else
		{
			FString UniqueName = GenerateUniqueName(GetWorld(), this, GetName());
			Rename(*UniqueName);
		}		
	}
}

void UMujocoJointComponent::PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) 
{
	Super::PostEditChangeProperty(PropertyChangedEvent);
	if (GEngine && GetWorld())
	{
		FString UniqueName = GenerateUniqueName(GetWorld(), this, GetName());
		Rename(*UniqueName);
	}
}
#endif
