#include "Misc/UniqueNamedComponent.h"
#include "UObject/UnrealType.h"
#include "EngineUtils.h"

FString TUniqueNamedComponent::GenerateUniqueName(UWorld* World, UActorComponent* Skip, const FString& BaseName) const
{
	int32 Counter = 1;
	FString NewName = BaseName;

	TSet<FString> ExistingNames;
	for (TActorIterator<AActor> It(World); It; ++It)
	{
		AActor* Actor = *It;
		for (UActorComponent* Component : Actor->GetComponents())
		{
			if (Component && Skip != Component)
			{
				ExistingNames.Add(Component->GetName());
			}
		}
	}

	while (ExistingNames.Contains(NewName))
	{
		NewName = BaseName + FString::Printf(TEXT("_%d"), Counter++);
	}

	return NewName;
}
