#pragma once

#include "CoreMinimal.h"
#include "Enums/MujocoEnums.h"
#include "Components/SceneComponent.h"
#include "Structs/MujocoJoint.h"
#include "Misc/UniqueNamedComponent.h"
#include "MujocoJointComponent.generated.h"

UCLASS(Blueprintable, ClassGroup = (Rendering, Common), hidecategories = (Object, Activation, "Components|Activation"), editinlinenew, meta = (BlueprintSpawnableComponent))
class LUCKYMUJOCO_API UMujocoJointComponent : public USceneComponent, public TUniqueNamedComponent
{
	GENERATED_BODY()

public:
	UMujocoJointComponent();

	UPROPERTY(Transient, VisibleAnywhere, Category = "Mujoco")
	int32 MujocoID = -1;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco")
	FMujocoJoint Joint;

#if WITH_EDITORONLY_DATA
	virtual void OnComponentCreated() override;
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
#endif
};
