#pragma once

#include "mujoco/mujoco.h"
#include "CoreMinimal.h"

struct LUCKYMUJOCO_API MujocoModelDeleter
{
	void operator()(mjModel_* ptr) const;
};

struct LUCKYMUJOCO_API MujocoDataDeleter
{
	void operator()(mjData_* ptr) const;
};

typedef TUniquePtr<mjModel_, MujocoModelDeleter> TMujocoModelPtr;
typedef TUniquePtr<mjData_, MujocoDataDeleter> TMujocoDataPtr;

template <typename... Args> TMujocoModelPtr MakeMujocoModelPtr(Args&&... args)
{
	return TMujocoModelPtr(std::forward<Args>(args)..., MujocoModelDeleter());
}

template <typename... Args> TMujocoDataPtr MakeMujocoDataPtr(Args&&... args)
{
	return TMujocoDataPtr(mj_makeData(std::forward<Args>(args)...), MujocoDataDeleter());
}
