#pragma once

#include "CoreMinimal.h"
#include "Enums/MujocoEnums.h"
#include "MujocoSite.generated.h"

USTRUCT(BlueprintType)
struct FMujocoSite
{
	GENERATED_BODY()				

	/** Type of geometric shape. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco", meta = (Attribute = "type"))
	EMujocoShapeType Type = EMujocoShapeType::Sphere;

	/** Integer group to which the site belongs. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco", meta = (Attribute = "group"))
	TOptional<int32> Group;

	/** Color and transparency. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco", meta = (Attribute = "rgba"))
	TOptional<FVector4> Rgba;

	/** Sizes of the geometric shape representing the site. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco", meta = (Attribute = "size"))
	TOptional<FVector> Size;
};